;dosstub.exe -- console applet that writes a tidy customized DOS stub to a PE.
;For use in build files.

comment| Sample build file for dosstub.exe itself:
@echo off
\masm32\bin\ml /c /coff dosstub.asm
if errorlevel 1 goto problem
\masm32\bin\Link /SUBSYSTEM:CONSOLE /STACK:4096 /HEAP:4096 dosstub.obj
if errorlevel 1 goto problem
del dosstub.obj
rem ---- To apply dosstub to itself, we need to use a copy:
copy dosstub.exe dosstub$.exe /y
dosstub$ dosstub.exe
del dosstub$.exe
dir dosstub.exe
goto end
:problem
echo ******** problem
:end
|

.586
.model flat, stdcall
option casemap:none

include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib

cr equ 0Dh
lf equ 0Ah
STD_OUTPUT_HANDLE equ -11
OPEN_EXISTING equ 3
GENERIC_READ  equ 80000000h
GENERIC_WRITE equ 40000000h
FILE_ATTRIBUTE_NORMAL equ 80h
LMEM_ZEROINIT equ 40h

.data
NewDosStub_ equ 80h
NewDosStub label byte
   db "MZ"    ;exe file signature
   dw 80h,1   ;exe size: bytes in the last 512-byte sector, number of sectors (rounded up).
   dw 0       ;exe relocation count
   dw 4       ;exe header size in paragraphs
   dw 1,1     ;extra paragraphs needed & wanted (just 1 to round up the allocation given by DOS)
   dw -10h,100h  ;initial ss, sp. ss=-10h gives ss=cs on entry
org 3Ch+NewDosStub
   dd 80h        ;file site of the letters "PE"
   db 0BAh,0Ch,1,0B4h,9,0CDh,21h,0B8h,1,4Ch,0CDh,21h
StubMessage$ label byte
org NewDosStub_+NewDosStub
PETable_ equ 78h
PETable label byte   ;we will read the incoming PE table to this site,
PESignature dd ?     ;and we give names to some of its many fields
    org 6+PETable
SectionCount dw ?
    org 18h+PETable
MagicNumber dw ?
    org 54h+PETable
SizeOfHeaders dd ?
    org 74h+PETable
DirsCount dd ?

hStdOut dd 0
hRead dd 0
hWrite dd 0
BlankFileSector dd 0      ;a mem handle
DirsSize dd ?
DirsCopy dd 0             ;a mem handle
SectionTableSize dd ?
SectionTable dd 0         ;a mem handle
PaddingNeeded dd ?

ExitAddress dd ?
Parm dd ?        ;an address in the stack, where we put a copy of
Parm_ equ 60h    ;  the filename (without path)
CmdLine dd ?     ;an address in the stack, for copy of the command line
CmdLine_ equ 0A0h
CmdTail dd ?  ;a site in CmdLine where there should be a filespec to open

NewHeaderSize label dword
FileNotFound$ db 16,"File not found",cr,lf
MZmissing$ db 24,"File does not begin MZ",cr,lf
BadPE$ db 73,"File is missing the PE signature or the optional header signature 0x10B",cr,lf
OutOfMemory$ db 15,"Out of memory",cr,lf
CantWrite$ db 21,"Write-access denied",cr,lf
CantExpandHeader$ db 50,"Nothing done -- no room in the PE header section",cr,lf
Usage$ db Usage_
    db "Usage: dosstub <filespec>",cr,lf
    db "Writes a custom DOS stub to a PE file.",cr,lf
Usage_ equ $-1-Usage$

ThisProgram$ db "This program"
ThisProgram_ equ $-ThisProgram$
StubText$ db " requires 32-bit Windows.",cr,lf,"$"
StubText_ equ $-StubText$

.code
comment| A debugging routine, dumps eax to the console, and exits:
dumpeax:
    push edx
    mov edx,esp
    push 0A0Dh      ;cr+lf
    sub esp,8
    mov edi,esp
    push "=xae"
    mov ebx,esp
    mov ecx,4
@@: rol eax,8
    push eax
    call _al2hexax
    stosw
    pop eax
    loop @B
    invoke WriteConsoleA,hStdOut,ebx,14,edx,0
    jmp quit

_al2hexax: mov ah,al
    shr ah,4
    call @F
    xchg al,ah
@@: and al,0Fh
    cmp al,0Ah
    sbb al,69h
    das
    ret
|

BadPE:
    mov esi,offset BadPE$
    jmp short SayAndGo
Usage:
    mov esi,offset Usage$
    jmp short SayAndGo
OutOfMemory:
    mov esi,offset OutOfMemory$
SayAndGo:
    call WriteConsoleD1
quit:
    xor eax,eax
    jmp ExitAddress

szCopyLimited:     ;from esi to edi, max length ecx including the zero
@@: lodsb
    stosb
    or al,al
    jz short @F
    loop @B
    mov [edi-1],cl  ;0
@@: ret

WriteConsoleD1:  ;input is esi
    xor eax,eax
    push eax     ;make space to dump the amount written
    mov edx,esp
    push eax     ;0 for WriteConsoleA
    lodsb        ;so eax is the amount to write
    push edx
    push eax
    push esi
    push hStdOut
    call WriteConsoleA
    pop eax
    ret

Start:
    pop ExitAddress
    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hStdOut,eax
    sub esp,Parm_
    mov Parm,esp
    sub esp,CmdLine_
    mov CmdLine,esp
    call GetCommandLine
    mov edi,esp
    xchg eax,esi
    mov ecx,CmdLine_
    call szCopyLimited
    mov esi,CmdLine
BypassCmdName:
    lodsb
    cmp al,0
    je Usage
    cmp al," "
    je short BypassSpaces
    cmp al,9         ;tab
    jne BypassCmdName
BypassSpaces:
    lodsb
    cmp al," "
    je short BypassSpaces
    cmp al,9
    je short BypassSpaces
    cmp al,0
    je Usage   ;no cmd tail provided
    dec esi
    mov CmdTail,esi  ;address of a filespec to open
StartParm:
    mov edi,Parm
CopyParm:
    lodsb
    stosb
    cmp al,"\"
    je short StartParm     ;trim away the path from the filespec
    cmp al,0
    je short GotParm
    cmp al," "
    je short GotParm
    cmp al,9
    jne short CopyParm
GotParm:
    dec edi
    mov byte ptr[edi],0
    mov ecx,edi
    mov esi,Parm
    sub ecx,esi
    cmp ecx,24    ;max filespec size that will fit in the stub
    jna short @F
    mov esi,offset ThisProgram$
    mov ecx,ThisProgram_
@@: mov edi,offset StubMessage$
    rep movsb
    mov esi,offset StubText$
    mov ecx,StubText_
    rep movsb
    invoke CreateFileA,CmdTail,GENERIC_READ,ecx,ecx,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,ecx
    inc eax
    mov esi,offset FileNotFound$
    jz SayAndGo
    dec eax
    mov hRead,eax
    push edx        ;make room on the stack to dump the amount read
    mov edx,esp
    push ecx        ;make a 4-byte read buffer on the stack
    mov ecx,esp     ;point at it
    invoke ReadFile,eax,ecx,2,edx,0
    pop eax
    pop edx
    mov esi,offset MZmissing$
    cmp ax,"ZM"
    jne SayAndGo
    invoke SetFilePointer,hRead,3Ch,0,0 ;get the offset of "PE"
    push eax
    mov edx,esp
    push eax         ;make a 4-byte read buffer
    mov ecx,esp
    invoke ReadFile,hRead,ecx,4,edx,0
    pop eax     ;what was read
    pop edx     ;amount read
    invoke SetFilePointer,hRead,eax,0,0  ;set file ptr to the location of "PE"
    inc eax
    jz BadPE
    push edx
    mov edx,esp
    invoke ReadFile,hRead,addr PETable,PETable_,edx,0
    pop edx
    cmp PESignature,"EP"
    jnz BadPE
    cmp MagicNumber,10Bh  ;a constant, denotes the presence of the section table etc.
    jnz BadPE
    mov eax,DirsCount
    shl eax,3
    mov DirsSize,eax
    xchg eax,esi
    invoke LocalAlloc,0,esi
    or DirsCopy,eax
    jz OutOfMemory
    push edx
    mov edx,esp
    invoke ReadFile,hRead,eax,esi,edx,0
    pop edx
    movzx eax,SectionCount
    shl eax,3    ;multiply eax by 8*5, which is the number of bytes in one section record
    lea eax,[eax+4*eax]
    mov SectionTableSize,eax
    xchg eax,esi
    invoke LocalAlloc,0,esi
    or SectionTable,eax
    jz OutOfMemory
    push edx
    mov edx,esp
    invoke ReadFile,hRead,eax,esi,edx,0
    pop edx
    invoke CloseHandle,hRead
    mov eax,NewDosStub_+PETable_  ;if the current DOS stub is < 80h bytes, we
    add eax,DirsSize              ;   need to avoid enlarging it too much
    add eax,SectionTableSize
    sub eax,SizeOfHeaders
    mov esi,offset CantExpandHeader$
    ja SayAndGo
    neg eax
    mov PaddingNeeded,eax
    invoke CreateFileA,CmdTail,GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
    or hWrite,eax
    mov esi,offset CantWrite$
    jz SayAndGo      ;this could well happen, if say the PE is a dll currently in use
    xchg eax,esi
    push edx
    mov edx,esp
    invoke WriteFile,esi,addr NewDosStub,NewDosStub_+PETable_,edx,0
    mov edx,esp
    invoke WriteFile,esi,DirsCopy,DirsSize,edx,0
    mov edx,esp
    invoke WriteFile,esi,SectionTable,SectionTableSize,edx,0
         ;we want to erase any debris in the PE file's header section:
    invoke LocalAlloc,LMEM_ZEROINIT,PaddingNeeded  ;a bunch of zeros; the stack could also be used
    or eax,eax
    jz short @F
    mov edx,esp
    invoke WriteFile,esi,eax,PaddingNeeded,edx,0
@@: invoke CloseHandle,hWrite      ;probably not necessary
    jmp quit

end Start
